#ifndef CHECKUP_H
#define CHECKUP_H

#include <minirex.h>
#include <stdio.h>
#include <sys/statvfs.h>


#define MAX_ANGLE               0.056       // Tolerance on the inclinometers angles
#define KINECT_INCLINATION      1.25        // Tolerance on the Kinect inclination

class CheckUp
{
public:
    CheckUp();
    ~CheckUp();

    void            Robot_CheckUp(MiniRex*);
    void            DisplaySuccessMessage(const char* Message);
    void            DisplayErrorMessage(const char *);
    void            DisplayErrorMessageAndValid(MiniRex* Robot,const char *);


private :
    char            Check_ConfigFile(MiniRex* Robot);
    char            Check_Firmware(MiniRex* Robot);
    void            Check_Batteries(MiniRex* Robot);
    void            Check_PushButton(MiniRex* Robot);
    void            Check_Inclinometer(MiniRex* Robot);
    void            Check_Servomotor(MiniRex* Robot);
    void            Check_Tracks(MiniRex* Robot);
    void            Check_UltraSonic(MiniRex* Robot);
    void            Check_DiskFreeSpace(MiniRex* Robot);
    void            Check_DataDirectory(MiniRex *Robot);
    void            Check_Kinect(MiniRex *Robot);


};

#endif // CHECKUP_H
