#ifndef FirmWare_H
#define FirmWare_H

#include <serialib.h>
#include <stdio.h>





#define         LEFT_US_SENSOR          1                       // ID of each us sensor
#define         CENTER_US_SENSOR        2
#define         RIGHT_US_SENSOR         3

//#define         __DEBUG_FirmWare__

class FirmWare
{
public:
    FirmWare();
    ~FirmWare();

    // Connection with the firmware, Kinect and Lidar

    char                LoadConfigFile();
    char                Init(char* Device);
    void                CloseFirmWare();

    // Accessories (Batteries, inclinometer, button ...)

    char                GetBatteryVoltage_mV(unsigned short *BatteryElec,unsigned short *BatteryPower);
    char                GetRollPitch(float *Roll, float *Pitch);
    char                GetButtonStatus();

    // Servomotor

    char                GetServoPosition(unsigned short *Position);
    char                SetServoPosition(unsigned short Position);
    char                SetServoSpeed(unsigned short Speed);

    // Tracks

    char                Tracks_GetPosition(int *LeftPos, int *RightPos);
    char                Tracks_GetCurrent(int *LeftCurrent, int *RightCurrent);
    char                Tracks_Enable();
    char                Tracks_SetVelocity(short Left, short Right);
    char                Tracks_SetAcceleration(short Acc);

    // Ultrasonic sensors

    char                US_RequestMeasurement(unsigned char US_ID);
    char                US_GetRange(unsigned char US_ID, short *Range);
    char                US_FullMeasurement(unsigned char US_ID,short *Range);




private:
    serialib            Firmware;
    bool                FirmWareConnected;                                      // Flag to check if the PC is connected to the firmware
    bool                LidarConnected;                                         // Flag to check if the PC is connected to the lidar


    char                SendPacket(unsigned char *Buffer, unsigned int Size);
    char                CheckFrame(unsigned char *Buffer);

};

#endif // FirmWare_H
