#ifndef MINIREX_H
#define MINIREX_H

#include <FirmWare.h>
#include <KinectClass.h>
#include <Lidar_Hokuyo.h>





class MiniRex
{
public:
    MiniRex();

    char                            Init(const char *Config_File_Path);

    KinectClass                     Kinect;
    FirmWare                        Firmware;
    Lidar_Hokuyo                    Hokuyo;

    char                            LoadConfigFile(const char* FileName);

    char                            Data_directory[1024];                                   // Directory used for saving data
    int                             Robot_ID;                                               // Number of the robot 1,2,3,...



private:

    char                            Firmware_device[1024];                                  // Device for the firmware
    char                            Lidar_device[1024];                                    // Device for the lidar
    char                            Kinect_config_file[1024];


};

#endif // MINIREX_H
